//
//  ViewController.m
//  drag_drag_look
//
//  Created by 王超 on 16/7/26.
//  Copyright © 2016年 王超. All rights reserved.
//

#import "ViewController.h"
#import "AboutViewController.h"

@interface ViewController ()

@property(nonatomic)int curVal; // 滑块当前的值
@property(nonatomic)int targetVal; // 目标值（随机生成的数）
@property(nonatomic)int score; // 得分
@property(nonatomic)int count; // 回合数

@property (weak, nonatomic) IBOutlet UISlider *slider;
// 分数显示文本
@property (weak, nonatomic) IBOutlet UILabel *scoreLabel;
// 回合数显示文本
@property (weak, nonatomic) IBOutlet UILabel *countLabel;

@end

@implementation ViewController

// 生成新的随机数，将滑块的值设置为50，并设置得分、回合数文本的显示值
- (void)startNewRound {
    _targetVal = 1 + arc4random() % 100;
    _curVal = 50;
    _slider.value = _curVal;
    _scoreLabel.text = [NSString stringWithFormat:@"%d", _score];
    _countLabel.text = [NSString stringWithFormat:@"%d", _count];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    [self startNewRound];
}

// 点击猜猜看按钮触发的事件
- (IBAction)showAlert:(id)sender {
    int diff = abs(_curVal - _targetVal);
    int points = 100 - diff;
    NSString *title = nil;
    
    if (diff == 0) {
        title = @"土豪你太牛B了！";
        points += 100;
    } else if (diff < 5) {
        title = @"土豪你太棒了，差一点！";
        if (diff == 1) {
            points += 50;
        }
    } else if (diff < 10) {
        title = @"好吧，勉强算个土豪！";
    } else {
        title = @"不是土豪少来装！";
    }
    _score += points;
    _count++;
    
    NSString *msg = [NSString stringWithFormat:@"恭喜高富帅，你的得分是：%d", points];
    UIAlertController *alertCtr = [UIAlertController alertControllerWithTitle:title message:msg preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction *alertAction = [UIAlertAction actionWithTitle:@"朕已知晓，爱卿辛苦了" style:UIAlertActionStyleDefault handler: ^(UIAlertAction *action){
        [self startNewRound];
    }];
    [alertCtr addAction:alertAction];
    [self presentViewController:alertCtr animated:YES completion:nil];
    
}

// 滑块值改变的事件
- (IBAction)slideMove:(id)sender {
    UISlider *slider = (UISlider *)sender;
    _curVal = (int)lroundf(slider.value);
}

// 重新来过按钮点击事件
- (IBAction)redo:(id)sender {
    _targetVal = 1 + arc4random() % 100;
    _curVal = 50;
    _score = 0;
    _count = 0;
    _slider.value = _curVal;
    _scoreLabel.text = [NSString stringWithFormat:@"%d", _score];
    _countLabel.text = [NSString stringWithFormat:@"%d", _count];
}

// 显示信息事件
- (IBAction)showInfo:(id)sender {
    AboutViewController *controller = [[AboutViewController alloc] initWithNibName:@"AboutViewController" bundle:nil];
    controller.modalPresentationStyle = UIModalTransitionStyleFlipHorizontal;
    [self presentViewController:controller animated:YES completion:nil];
}
@end
